#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Mentat::Message::Grouper module/class tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
#
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 4;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Mentat::Message::Grouper';

        use_ok('Tester');
        use_ok($TESTED_CLASS);
        use_ok('Mentat::Message::Factory');
    }

# Debug output explicit ON switch
#Tester::DEBUG_ON();

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
diag("$TESTED_CLASS version: " . $Mentat::Message::Grouper::VERSION) if Tester::D();
diag("Mentat::Message::Factory version: " . $Mentat::Message::Factory::VERSION) if Tester::D();

# Now attempt to create a class instance and check it
my $instance = $TESTED_CLASS->new();
isa_ok($instance, $TESTED_CLASS);

# View the created instance
diag("Instance dump 01: " . Dumper($instance)) if Tester::D();

my $message01 = Mentat::Message::Factory->from_file('./data/alert01.idea');
my $message02 = Mentat::Message::Factory->from_file('./data/alert02.idea');
my $message03 = Mentat::Message::Factory->from_file('./data/alert03.idea');
my $message04 = Mentat::Message::Factory->from_file('./data/alert04.idea');
my $message05 = Mentat::Message::Factory->from_file('./data/alert05.idea');
my $message06 = Mentat::Message::Factory->from_file('./data/alert06.idea');
my $message07 = Mentat::Message::Factory->from_file('./data/alert07.idea');
my $message08 = Mentat::Message::Factory->from_file('./data/alert08.idea');
my $message09 = Mentat::Message::Factory->from_file('./data/alert09.idea');
my $message10 = Mentat::Message::Factory->from_file('./data/alert10.idea');

my $messages = [$message01, $message02, $message03, $message04, $message05, $message06, $message07, $message08, $message09, $message10];

#my $mpath = 'Alert/Classification/@text';
my $mpath = 'Alert/Source/Node/Address/address';
my $how = ['Alert/Classification/@text',
           'Alert/Source/Node/Address/address',
          ];

#print Dumper($instance->group($mpath, $messages));
print Dumper($instance->group_multi($how, $messages));
